<?php

// IPplan v4.31
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../xmllib.php");

// function to generate swip entry - returns a string with swip
// which can then be displayed/emailed etc
function genSWIP($ds, $start, $end, $cust, $descrip, $filename) {

   global $ntnameopt;

   $result1=&$ds->ds->Execute("SELECT *
                         FROM custinfo
                         WHERE customer=$cust");
   // should only be one row here, none if SWIP turned off during creation
   // of customer
   $row1=$result1->FetchRow();

   $result2=&$ds->ds->Execute("SELECT hname, ipaddr
                         FROM revdns
                         WHERE customer=$cust
                         ORDER BY horder");

   $fields=array();
   $fields["ntsnum"]=$start;
   $fields["ntenum"]=$end;
   $fields=array_merge($fields, $row1);

   // use subnet description field? then only a-z, 0-9 max 21 chars allowed
   if ($ntnameopt and preg_match("/^[A-Za-z0-9\-]{1,21}$/", $descrip)) {
      $ntname=$descrip;
   }
   else {
      $ntname=MAINTAINERID."-".str_replace(".", "-", $start);
   }
   $fields["ntname"]=$ntname;
   $fields["maint"]=MAINTAINERID;

   $row2 = $result2->FetchRow();
   $fields["hname1"]=$row2["hname"];
   $fields["ipaddr1"]=$row2["ipaddr"];

   $row2 = $result2->FetchRow();
   $fields["hname2"]=$row2["hname"];
   $fields["ipaddr2"]=$row2["ipaddr"];

   $row2 = $result2->FetchRow();
   $fields["hname3"]=$row2["hname"];
   $fields["ipaddr3"]=$row2["ipaddr"];

   $cnt=3;
   while($row2 = $result2->FetchRow()) {
      $fields["hname$cnt"]=$row2["hname"];
      $fields["ipaddr$cnt"]=$row2["ipaddr"];
      $cnt++;
   }

   $rep = new myTemplate;
   if ($rep->get("../templates/$filename") == FALSE)
      return FALSE;
   $swip=$rep->process($fields);

   return $swip;
}

// email the swip entry
function emailSWIP($swip) {

    $header="From: ".SWIPADMINEMAIL."\n".
            "Reply-To: ".SWIPADMINEMAIL."\n".
            "X-Mailer: PHP/" . phpversion();

    mail(SWIPEMAIL, "SWIP",
             $swip, $header);
}

?>
